/**
 * Exercsies the TreeMap implementation as defined in tree-map.h. 
 */

#include <string>
#include <iostream>
#include <cassert>
#include "console.h"
#include "tree-map.h"
using namespace std;

static void integerTest() {
    TreeMap<int, int> ihm;
    ihm[45] = 70;
    assert(ihm.containsKey(45) && ihm.get(45) == 70 && ihm[45] == 70);
    ihm[45] = 700;
    assert(ihm.containsKey(45) && ihm.get(45) == 700 && ihm[45] == 700);
    assert(!ihm.containsKey(80) && ihm.get(80) == 0 && ihm[80] == 0 && ihm.containsKey(80));
    for (int key = 81; key < 700; key++) {
        assert(!ihm.containsKey(key) && ihm.get(key) == int());
    }
}

static void stringTest() {
    TreeMap<string, string> shm;
    shm["happy"] = "go lucky";
    assert(shm.containsKey("happy") && shm.get("happy") == "go lucky" && shm["happy"] == "go lucky");
    shm["happy"] = "as a clam";
    assert(shm.containsKey("happy") && shm.get("happy") == "as a clam" && shm["happy"] == "as a clam");
    assert(!shm.containsKey("running on") && shm.get("running on") == "" &&
           shm["running on"] == "" && shm.containsKey("running on"));
}

int main() {
    integerTest();
    stringTest();
    cout << "If you got this far, then the TreeMap works for primitives and for strings." << endl;
    return 0;
}
